import { Unsubscribe } from './subscriptions';
export declare type CollectionListener<Entry> = (colletion: Collection<Entry>, change: Change<Entry>) => void;
export interface Entries<Entry> {
    [key: string]: Entry | undefined;
}
export interface CollectionMethods<Entry> {
    subscribe(listener: CollectionListener<Collection<Entry>>): Unsubscribe;
    unsubscribe(onUpdate: CollectionListener<Collection<Entry>>): void;
    toArray(): Entry[];
}
export declare type Collection<Entry, Methods = {}> = Entries<Entry> & CollectionMethods<Entry> & Methods;
export interface Change<Entry> {
    id: string;
    change: 'set' | 'delete';
    entry: Entry;
}
export declare function createCollection<Entry, Methods = {}>(entries?: Entries<Entry>, methods?: (c: Collection<Entry, Methods>) => Methods): Collection<Entry, Methods>;
