/**
 * Listens for changes to `T` objects
 */
export declare type Listener<T> = (t: T) => void;
/**
 * Unsubscribes a Listener when called
 */
export declare type Unsubscribe = () => void;
/**
 * A map of keysof T to booleans.
 *
 * @example
 *
 * In the example below the `name` will be watched.
 *
 * ```js
 * interface User {
 *  name: string
 *  age: number
 * }
 *
 * let sub: SubscribeTo<User> = { name: boolean }
 * ```
 */
export declare type SubscribeTo<T> = {
    [P in keyof T]?: boolean;
};
